=== Maintenance/deb/sid/debian/changelog ===
cgal (4.1-1) unstable; urgency=low

  * New upstream release.
  * Rename binary package libcgal9 to libcgal10 to reflect SONAME change.
  * Configure CGAL using -DCGAL_ENABLE_PRECONFIG=OFF since we do not want
    that the accidential presence of optional libraries (for demos and
    examples) influences the build of the library.
  * Move the Qt4 support library and the corresponding headers into new
    binary packages libcgal-qt4-10 and libcgal-qt4-dev (Closes: #683214).
  * Add libboost-system-dev to Builds-Depends: of cgal.
  * Move libmpfi-dev from Suggests: of cgal-demo to Build-Depends: of cgal.

 -- Joachim Reichel <reichel@debian.org>  Wed, 24 Oct 2012 19:08:35 +0200

cgal (4.0.2-1) unstable; urgency=low

  * New upstream release.
  * Remove gcc-4.7 patch (fixed upstream).

 -- Joachim Reichel <reichel@debian.org>  Wed, 04 Jul 2012 19:45:28 +0200

cgal (4.0-4) unstable; urgency=low

  * Add Suggests: libeigen3-dev (>= 3.1.0~beta1-1), libmpfi-dev to
    libcgal-demo.

 -- Joachim Reichel <reichel@debian.org>  Tue, 12 Jun 2012 23:53:14 +0200

cgal (4.0-3) unstable; urgency=low

  * Change Build-Depends: debhelper (>= 8) to debhelper (>= 9), update
    debian/compat to get the default build flags for hardening. Inject
    CPPFLAGS into CFLAGS and CXXFLAGS, since CPPFLAGS is ignored by cmake.
  * Add lintian override to silence incorrect warnings about
    hardening-no-fortify-functions for some libraries (all libraries are
    built with the same flags).

 -- Joachim Reichel <reichel@debian.org>  Sun, 10 Jun 2012 15:36:27 +0200

cgal (4.0-2) unstable; urgency=low

  * Add patch gcc-4.7 to fix a syntax error in template code which is
    not instantiated during the package build itself (Closes: #673554).
  * Fix debian/watch.

 -- Joachim Reichel <reichel@debian.org>  Sun, 20 May 2012 22:47:56 +0200

cgal (4.0-1) unstable; urgency=low

  * New upstream release.
  * Move from non-free to main due to upstream license change from QPL
    to GPL 3+ (and from LGPL 2.1 to LGPL 3+), updated debian/copyright
    accordingly.
  * Rename binary package libcgal8 to libcgal9 to reflect SONAME change.
  * Update Standards-Version to 3.9.3 (no changes needed).
  * Remove fix-ipe-version-detection.dpatch and
    fix-qt-moc-parse-error.dpatch (fixed upstream).
  * Removed libmagick++9-dev from Suggests: of libcgal-demo, because
    that package does no longer exists.

 -- Joachim Reichel <reichel@debian.org>  Mon, 12 Mar 2012 19:14:55 +0100

cgal (3.9-4) unstable; urgency=low

  * Rebuild against boost 1.48 (Closes: #659358).
  * Add fix-qt-moc-parse-error.dpatch as workaround for
    https://bugreports.qt-project.org/browse/QTBUG-22829.

 -- Joachim Reichel <reichel@debian.org>  Fri, 10 Feb 2012 22:41:26 +0100

cgal (3.9-3) unstable; urgency=low

  * Fix FTBFS when building only architecture dependent packages caused
    by recent transition to the new packaging format (Closes: #658191).

 -- Joachim Reichel <reichel@debian.org>  Wed, 01 Feb 2012 00:07:03 +0100

cgal (3.9-2) unstable; urgency=low

  * Changed packaging format to "3.0 (quilt)".
  * Add fix-ipe-version-detection.dpatch: upstream patch for bug #643278.
    Remove workaround.
  * Tighten Depends: of libcgal-ipelets on ipe (Closes: #657720).
  * Move libcgal-ipelets to Section: graphics.
  * Add libqt4-opengl-dev to Suggests: of libcgal-demo.

 -- Joachim Reichel <reichel@debian.org>  Mon, 30 Jan 2012 19:04:18 +0100

cgal (3.9-1) unstable; urgency=low

  * New upstream release.
  * Rename binary package libcgal7 to libcgal8 to reflect SONAME change.
  * Add workaround for bug #643278.

 -- Joachim Reichel <reichel@debian.org>  Wed, 28 Sep 2011 19:51:35 +0200

cgal (3.8-1) unstable; urgency=low

  * New upstream release.
  * Rename binary package libcgal6 to libcgal7 to reflect SONAME change.
  * Update Standards-Version to 3.9.2 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Thu, 21 Apr 2011 18:45:25 +0200

cgal (3.7-5) unstable; urgency=low

  * Upload to unstable.

 -- Joachim Reichel <reichel@debian.org>  Sun, 06 Mar 2011 17:26:11 +0100

cgal (3.7-4) experimental; urgency=low

  * Build with libgmp10 (Closes: #614797). Thanks to Christian M. Amsüss.

 -- Joachim Reichel <reichel@debian.org>  Sun, 27 Feb 2011 16:36:22 +0100

cgal (3.7-3) unstable; urgency=low

  * Disable support for Qt3 because Qt3 has been removed from the repository
    (Closes: #604478).

 -- Joachim Reichel <reichel@debian.org>  Thu, 10 Feb 2011 21:06:09 +0100

cgal (3.7-2) unstable; urgency=low

  * Upload to unstable.

 -- Joachim Reichel <reichel@debian.org>  Sun, 06 Feb 2011 13:53:00 +0100

cgal (3.7-1) experimental; urgency=low

  * New upstream release.
  * Rename binary package libcgal5 to libcgal6 to reflect SONAME change.
  * Rename binary package libcgal5-ipelets to libcgal-ipelets because it is
    not possible to install the ipelets for different SONAMEs in parallel.
  * Remove ipe-default-to-version-7.dpatch: the Ipe version is now
    auto-detected.
  * Remove fix-core-64bit.dpatch (fixed upstream).
  * Add qt4-dev-tools to Suggests: of libcgal-demo for qcollectiongenerator.
  * Update Standards-Version to 3.9.1 (-D_REENTRANT no longer needed).

 -- Joachim Reichel <reichel@debian.org>  Sun, 17 Oct 2010 14:27:54 +0200

cgal (3.6.1-2) unstable; urgency=low

  * Add fix-core-64bit.dpatch: use CORE::CHUNK_BIT instead of hard-coded
    constant 14.

 -- Joachim Reichel <reichel@debian.org>  Tue, 24 Aug 2010 19:46:36 +0200

cgal (3.6.1-1) unstable; urgency=low

  * New upstream release.
  * Set SOVERSION explicitly to 5.0.1 as told by upstream.
  * Remove architecture exceptions from Suggests: for libcgal-demo which is no
    longer allowed by dpkg-gencontrol (see #560071).
  * Fix debian/watch file.
  * Change license of packaging to LGPL 2.1 or later because referencing the
    BSD license in /usr/share/common-licenses is deprecated.
  * Update Standards-Version to 3.9.0 (no changes needed).


