=== Maintenance/deb/wheezy/debian/changelog ===
cgal (4.1-1~wheezy1) testing; urgency=low

  * New upstream release.
  * Rename binary package libcgal9 to libcgal10 to reflect SONAME change.
  * Configure CGAL using -DCGAL_ENABLE_PRECONFIG=OFF since we do not want
    that the accidential presence of optional libraries (for demos and
    examples) influences the build of the library.
  * Move the Qt4 support library and the corresponding headers into new
    binary packages libcgal-qt4-10 and libcgal-qt4-dev (Closes: #683214).
  * Add libboost-system-dev to Builds-Depends: of cgal.
  * Move libmpfi-dev from Suggests: of cgal-demo to Build-Depends: of cgal.

 -- Joachim Reichel <reichel@debian.org>  Wed, 24 Oct 2012 19:08:35 +0200
